<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<html><head><title>
Xv Manual: Image region
</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta http-equiv="Content-Style-Type" content="text/css">
<link rel="stylesheet" title="Default" type="text/css" href="allegro.css"></head><body bgcolor=white text=black link="#0000ee" alink="#ff0000" vlink="#551a8b">
<h1><a name="Image region">Image region</a></h1>

<ul>
<li><a href="#"></a> 
<li><a href="#"></a> 
<li><a href="#"></a> 
<li><a href="#"></a> 
<li><a href="#add_image">add_image</a> 
<li><a href="#add_one_image">add_one_image</a> 
<li><a href="#add_to_image">add_to_image</a> 
<li><a href="#add_to_one_image">add_to_one_image</a> 
<li><a href="#affine_transform_all_image_unitset">affine_transform_all_image_unitset</a> 
<li><a href="#alloc_image">alloc_image</a> 
<li><a href="#alloc_one_image">alloc_one_image</a> 
<li><a href="#alloc_over_plane">alloc_over_plane</a> 
<li><a href="#build_an_empty_image_region">build_an_empty_image_region</a> 
<li><a href="#build_image_region">build_image_region</a> 
<li><a href="#cdbl_line_ptr">cdbl_line_ptr</a> 
<li><a href="#cflt_line_ptr">cflt_line_ptr</a> 
<li><a href="#close_movie_on_disk">close_movie_on_disk</a> 
<li><a href="#create_and_attach_ds_to_oi">create_and_attach_ds_to_oi</a> 
<li><a href="#create_and_attach_label_to_oi">create_and_attach_label_to_oi</a> 
<li><a href="#create_and_attach_movie_to_imr">create_and_attach_movie_to_imr</a> 
<li><a href="#create_and_attach_oi_to_imr">create_and_attach_oi_to_imr</a> 
<li><a href="#create_and_attach_op_to_oi">create_and_attach_op_to_oi</a> 
<li><a href="#create_and_attach_unit_set_to_oi">create_and_attach_unit_set_to_oi</a> 
<li><a href="#create_imreg_with_movie">create_imreg_with_movie</a> 
<li><a href="#create_one_image">create_one_image</a> 
<li><a href="#create_one_movie">create_one_movie</a> 
<li><a href="#dbl_line_ptr">dbl_line_ptr</a> 
<li><a href="#do_one_image">do_one_image</a> 
<li><a href="#draw_box_im">draw_box_im</a> 
<li><a href="#draw_box_imr_plot">draw_box_imr_plot</a> 
<li><a href="#duplicate_image">duplicate_image</a> 
<li><a href="#erase_imr_box">erase_imr_box</a> 
<li><a href="#extract_line">extract_line</a> 
<li><a href="#extract_raw_line">extract_raw_line</a> 
<li><a href="#extract_raw_row">extract_raw_row</a> 
<li><a href="#extract_raw_tilted_profile">extract_raw_tilted_profile</a> 
<li><a href="#extract_row">extract_row</a> 
<li><a href="#extract_tilted_profile">extract_tilted_profile</a> 
<li><a href="#fast_interpolate_image_point">fast_interpolate_image_point</a> 
<li><a href="#find_CTRL_Z_offset">find_CTRL_Z_offset</a> 
<li><a href="#find_im_cur_oi">find_im_cur_oi</a> 
<li><a href="#find_im_cur_op">find_im_cur_op</a> 
<li><a href="#find_imr_in_current_dialog">find_imr_in_current_dialog</a> 
<li><a href="#find_oi_cur_op">find_oi_cur_op</a> 
<li><a href="#find_op_nb_of_source_specific_ds_in_oi">find_op_nb_of_source_specific_ds_in_oi</a> 
<li><a href="#find_op_nb_of_treatement_specific_ds_in_oi">find_op_nb_of_treatement_specific_ds_in_oi</a> 
<li><a href="#find_zmin_zmax">find_zmin_zmax</a> 
<li><a href="#flt_line_ptr">flt_line_ptr</a> 
<li><a href="#free_image_region">free_image_region</a> 
<li><a href="#free_one_image">free_one_image</a> 
<li><a href="#get_cflt_pixel">get_cflt_pixel</a> 
<li><a href="#get_dbl_pixel">get_dbl_pixel</a> 
<li><a href="#get_flt_pixel">get_flt_pixel</a> 
<li><a href="#get_lint_pixel">get_lint_pixel</a> 
<li><a href="#get_oi_filename">get_oi_filename</a> 
<li><a href="#get_oi_history">get_oi_history</a> 
<li><a href="#get_oi_mode">get_oi_mode</a> 
<li><a href="#get_oi_path">get_oi_path</a> 
<li><a href="#get_oi_periodicity_in_x">get_oi_periodicity_in_x</a> 
<li><a href="#get_oi_periodicity_in_y">get_oi_periodicity_in_y</a> 
<li><a href="#get_oi_plot_axes">get_oi_plot_axes</a> 
<li><a href="#get_oi_region_of_interest_in_pixel">get_oi_region_of_interest_in_pixel</a> 
<li><a href="#get_oi_source">get_oi_source</a> 
<li><a href="#get_oi_title">get_oi_title</a> 
<li><a href="#get_oi_treatement">get_oi_treatement</a> 
<li><a href="#get_oi_type">get_oi_type</a> 
<li><a href="#get_oi_x_title">get_oi_x_title</a> 
<li><a href="#get_oi_x_top_title">get_oi_x_top_title</a> 
<li><a href="#get_oi_x_unit_name">get_oi_x_unit_name</a> 
<li><a href="#get_oi_y_right_title">get_oi_y_right_title</a> 
<li><a href="#get_oi_y_title">get_oi_y_title</a> 
<li><a href="#get_oi_y_unit_name">get_oi_y_unit_name</a> 
<li><a href="#get_oi_z_unit_name">get_oi_z_unit_name</a> 
<li><a href="#get_raw_pixel_value">get_raw_pixel_value</a> 
<li><a href="#get_rgb_pixel">get_rgb_pixel</a> 
<li><a href="#get_rgba_pixel">get_rgba_pixel</a> 
<li><a href="#get_sint_pixel">get_sint_pixel</a> 
<li><a href="#get_uchar_pixel">get_uchar_pixel</a> 
<li><a href="#get_uint_pixel">get_uint_pixel</a> 
<li><a href="#get_z_black_z_white_values">get_z_black_z_white_values</a> 
<li><a href="#get_zmin_zmax_values">get_zmin_zmax_values</a> 
<li><a href="#image_data">image_data</a> 
<li><a href="#imreadfile">imreadfile</a> 
<li><a href="#imreg">imreg</a> 
<li><a href="#inherit_from_ds_to_ds">inherit_from_ds_to_ds</a> 
<li><a href="#inherit_from_im_to_ds">inherit_from_im_to_ds</a> 
<li><a href="#inherit_from_im_to_im">inherit_from_im_to_im</a> 
<li><a href="#inherit_from_oi_to_ds">inherit_from_oi_to_ds</a> 
<li><a href="#inherit_from_oi_to_oi">inherit_from_oi_to_oi</a> 
<li><a href="#init_one_image">init_one_image</a> 
<li><a href="#interpolate_image_point">interpolate_image_point</a> 
<li><a href="#interpolate_RGB_picture_point">interpolate_RGB_picture_point</a> 
<li><a href="#is_oi_bottom_left_axes_in_pixel">is_oi_bottom_left_axes_in_pixel</a> 
<li><a href="#is_oi_bottom_left_axes_numbered">is_oi_bottom_left_axes_numbered</a> 
<li><a href="#is_oi_top_right_axes_in_pixel">is_oi_top_right_axes_in_pixel</a> 
<li><a href="#is_oi_top_right_axes_numbered">is_oi_top_right_axes_numbered</a> 
<li><a href="#is_oi_x_axes_same_as_plot">is_oi_x_axes_same_as_plot</a> 
<li><a href="#is_oi_y_axes_same_as_plot">is_oi_y_axes_same_as_plot</a> 
<li><a href="#lint_line_ptr">lint_line_ptr</a> 
<li><a href="#load_im_file_in_imreg">load_im_file_in_imreg</a> 
<li><a href="#map_pixel_ratio_of_image_and_screen">map_pixel_ratio_of_image_and_screen</a> 
<li><a href="#mcomplex">mcomplex</a> 
<li><a href="#mdcomplex">mdcomplex</a> 
<li><a href="#O_i">O_i</a> 
<li><a href="#pix">pix</a> 
<li><a href="#push_image_label">push_image_label</a> 
<li><a href="#refresh_im_plot">refresh_im_plot</a> 
<li><a href="#refresh_image">refresh_image</a> 
<li><a href="#remove_from_image">remove_from_image</a> 
<li><a href="#remove_from_one_image">remove_from_one_image</a> 
<li><a href="#remove_image">remove_image</a> 
<li><a href="#remove_one_image">remove_one_image</a> 
<li><a href="#reset_full_over_plane">reset_full_over_plane</a> 
<li><a href="#rgb">rgb</a> 
<li><a href="#rgb_line_ptr">rgb_line_ptr</a> 
<li><a href="#rgba">rgba</a> 
<li><a href="#rgba_line_ptr">rgba_line_ptr</a> 
<li><a href="#save_image_header">save_image_header</a> 
<li><a href="#save_one_image">save_one_image</a> 
<li><a href="#select_image_of_imreg">select_image_of_imreg</a> 
<li><a href="#select_image_of_imreg_and_display">select_image_of_imreg_and_display</a> 
<li><a href="#set_im_title">set_im_title</a> 
<li><a href="#set_im_x_title">set_im_x_title</a> 
<li><a href="#set_im_x_top_title">set_im_x_top_title</a> 
<li><a href="#set_im_x_unit_set">set_im_x_unit_set</a> 
<li><a href="#set_im_y_right_title">set_im_y_right_title</a> 
<li><a href="#set_im_y_title">set_im_y_title</a> 
<li><a href="#set_im_y_unit_set">set_im_y_unit_set</a> 
<li><a href="#set_im_z_unit_set">set_im_z_unit_set</a> 
<li><a href="#set_image_ending_time">set_image_ending_time</a> 
<li><a href="#set_image_starting_time">set_image_starting_time</a> 
<li><a href="#set_oi_bottom_left_axes">set_oi_bottom_left_axes</a> 
<li><a href="#set_oi_filename">set_oi_filename</a> 
<li><a href="#set_oi_history">set_oi_history</a> 
<li><a href="#set_oi_horizontal_extend">set_oi_horizontal_extend</a> 
<li><a href="#set_oi_mode">set_oi_mode</a> 
<li><a href="#set_oi_not_periodic">set_oi_not_periodic</a> 
<li><a href="#set_oi_not_periodic_in_x">set_oi_not_periodic_in_x</a> 
<li><a href="#set_oi_not_periodic_in_y">set_oi_not_periodic_in_y</a> 
<li><a href="#set_oi_path">set_oi_path</a> 
<li><a href="#set_oi_periodic_in_x">set_oi_periodic_in_x</a> 
<li><a href="#set_oi_periodic_in_x_and_y">set_oi_periodic_in_x_and_y</a> 
<li><a href="#set_oi_periodic_in_y">set_oi_periodic_in_y</a> 
<li><a href="#set_oi_plot_axes">set_oi_plot_axes</a> 
<li><a href="#set_oi_region_of_interest_in_pixel">set_oi_region_of_interest_in_pixel</a> 
<li><a href="#set_oi_source">set_oi_source</a> 
<li><a href="#set_oi_top_right_axes">set_oi_top_right_axes</a> 
<li><a href="#set_oi_treatement">set_oi_treatement</a> 
<li><a href="#set_oi_vertical_extend">set_oi_vertical_extend</a> 
<li><a href="#set_oi_x_unit_set">set_oi_x_unit_set</a> 
<li><a href="#set_oi_y_unit_set">set_oi_y_unit_set</a> 
<li><a href="#set_oi_z_unit_set">set_oi_z_unit_set</a> 
<li><a href="#set_over">set_over</a> 
<li><a href="#set_z_black_z_white_values">set_z_black_z_white_values</a> 
<li><a href="#set_zmin_zmax_values">set_zmin_zmax_values</a> 
<li><a href="#sint_line_ptr">sint_line_ptr</a> 
<li><a href="#swap_image">swap_image</a> 
<li><a href="#switch_frame">switch_frame</a> 
<li><a href="#switch_frame_of_disk_movie">switch_frame_of_disk_movie</a> 
<li><a href="#uchar_line_ptr">uchar_line_ptr</a> 
<li><a href="#uint_line_ptr">uint_line_ptr</a> 
<li><a href="#uns_oi_2_oi">uns_oi_2_oi</a> 
<li><a href="#uns_oi_2_oi_by_type">uns_oi_2_oi_by_type</a> 
<li><a href="#uns_oi_2_op">uns_oi_2_op</a> 
<li><a href="#uns_op_2_oi">uns_op_2_oi</a> 
<li><a href="#what_is_pixel_ratio_of_image_and_screen">what_is_pixel_ratio_of_image_and_screen</a> 
<li><a href="#x_imdata_2_imr">x_imdata_2_imr</a> 
<li><a href="#x_imr_2_im_user_data">x_imr_2_im_user_data</a> 
<li><a href="#x_imr_2_imdata">x_imr_2_imdata</a> 
<li><a href="#x_imr_2_pltdata">x_imr_2_pltdata</a> 
<li><a href="#x_pltdata_2_imr">x_pltdata_2_imr</a> 
<li><a href="#y_imdata_2_imr">y_imdata_2_imr</a> 
<li><a href="#y_imr_2_im_user_data">y_imr_2_im_user_data</a> 
<li><a href="#y_imr_2_imdata">y_imr_2_imdata</a> 
<li><a href="#y_imr_2_pltdata">y_imr_2_pltdata</a> 
<li><a href="#y_pltdata_2_imr">y_pltdata_2_imr</a> 
</ul>



<p><br>
the screen representation of images is an image region structure it is defined as follow:


<p><br>
<div class="al-api"><b>typedef struct image_region <a name="imreg">imreg</a>                    /* view of an image */</b></div><br>
<blockquote class="code"><pre>
{
        dybox db;                               /* boundary of it */
        rec def;                                /* def of position */   
        struct box stack, stack2;               /* box translation of plot */
        struct box *plt;                        /* box of plot */
        int x_off, y_off;                       /* the image bot. l. corner */
        int s_nx, s_ny;                         /* the image size on screen */
        int screen_scale, max_scale, min_scale; /* ratio from box to screen */
        float mag_step;                         /* magnification fac.*/
        int x0, y0;                             /* x &amp; y offset to box */
        dybox *l_db;                            /* list of active box */
        int n_db, m_db;                         /* number, alloced */
        <a href="#O_i" class="autotype" title="">O_i</a> *one_i;                             /* the im def */
        <a href="#O_i" class="autotype" title="">O_i</a> **o_i;                              /* the series of image */
        int n_oi, m_oi;                         /* the number of image */
        int cur_oi;                             /* the current one */
        int                     mark_v,mark_h;  /* the positions of markers */  
} 
</pre></blockquote>


<p><br>
An image region is a screen widget which goal is to display image data. This structure
may contains several images, in normal mode one image is displayed at a time.
Ne number of image in image region is given by n_oi, while the curent one is given
by c_oi. The real image data is contains in the following structure : 

<p><br>
<div class="al-api"><b>typedef struct one_image <a name="O_i">O_i</a></b></div><br>
<blockquote class="code"><pre>
{
        int type;
        char *filename, *dir, *title;   /* The strings defining the titles */
        char *x_title, *y_title, *x_prime_title, *y_prime_title;        
        char *x_prefix, *y_prefix, *x_unit, *y_unit;            
        float width, height, right, up;
        int iopt, iopt2;        
        float tick_len;
        float x_lo, x_hi, y_lo, y_hi;
        float z_black, z_white;         /* grey-scale def */
        float z_min, z_max;             /* grey-scale limit */  
        float ax, dx;                   /* conversion factor and offset */
        float ay, dy;                   /* between pixels and user dim */
        float az, dz;                   /* between pixels and user dim */
        float at, dt;                   /* between frame and time */
        struct <a href="#image_data" class="autotype" title="">image_data</a> im;
        struct plot_label **lab;        /* labelling in the plot */
        int n_lab, m_lab;
        <a href="xvin002.html#O_p" class="autotype" title="">O_p</a> **o_p;                      /* the series of plot */
        int n_op, m_op;                 /* the number of plot */
        int cur_op;                     /* the current one */
        <a href="xvin001.html#un_s" class="autotype" title="">un_s</a>    **xu;                   /* x unit set */
        int n_xu, m_xu, c_xu;
        <a href="xvin001.html#un_s" class="autotype" title="">un_s</a>    **yu;                   /* y unit set */
        int n_yu, m_yu, c_yu;   
        <a href="xvin001.html#un_s" class="autotype" title="">un_s</a>    **zu;                   /* z unit set */
        int n_zu, m_zu, c_zu;   
        <a href="xvin001.html#un_s" class="autotype" title="">un_s</a>    **tu;                   /* t unit set (for movies) */
        int n_tu, m_tu, c_tu;           
        struct hook bmp;                        /* use to attach a BITMAP */    
        int need_to_refresh;
} 
</pre></blockquote>

<p>
This data structure describes all the attributes of the image, its labels, associated
plots appearing over the image and the units structures associated with x, y, z and t.
An image may in fact be a movie, thus t axis refers to time. This structure pocesses
a serie of pointers allowing to handle the real pixel data. Xvin support a variety of
image data type more specifically designed for scientific usage. The memory associated to
each image is allocated in one memory chunk. A void pointer to each image is accessible
through mem[i] where i is the image number. This number must be smaller than n_f and 
greater or equal to 0. If the image just contains a single image only mem[0] is defined.
More specific data handling is provided to access each line of the image : for a given
frame of a movie, the pixel element is an array of pointer to the structure "pix" 
which allow to handle the different image type, pixel[i] is the pointer to line
i. Xvin display image have line 0 at the bottom ant line ny-1 at the top. However,
the location of these line in memory may be different.




<p><br>
<div class="al-api"><b>O_i* <a name="create_one_image">create_one_image</a> (int nx, int ny, int data_type);</b></div><br>
        This function create the O_i structure and allocate memory for one image.

<p><br>
<div class="al-api"><b>O_i* <a name="create_one_movie">create_one_movie</a> (int nx, int ny, int data_type, int nb_frames);</b></div><br>
        This function create the O_i structure and allocate memory for a movie.

<p><br>
<div class="al-api"><b>int <a name="free_one_image">free_one_image</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        This routine free all memory attached to one image and the image itself.

<p><br>
<div class="al-api"><b>O_i* <a name="duplicate_image">duplicate_image</a> (<a class="autotype" href="#O_i" title="">O_i</a> *src, <a class="autotype" href="#O_i" title="">O_i</a> *dest);</b></div><br>
        copy one image to another one, if dest is NULL, the image is created.


<p><br>
/* not to be used */
<div class="al-api"><b>int <a name="init_one_image">init_one_image</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, int type);</b></div><br>
        Internal function initializing the image structure.

<p><br>
<div class="al-api"><b>int <a name="alloc_one_image">alloc_one_image</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, int nx, int ny, int type);</b></div><br>
        Internal function allocating the image memory.

<p><br>
<div class="al-api"><b>int <a name="add_one_image">add_one_image</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, int type, void *stuff);</b></div><br>
<div class="al-api-cont"><b>int <a name="add_to_one_image">add_to_one_image</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int type, void *stuff);</b></div><br>
        general function used to attach more data (labels, plots, unitset ...) to one image

<p><br>
<div class="al-api"><b>int <a name="remove_one_image">remove_one_image</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, int type, void *stuff);</b></div><br>
<div class="al-api-cont"><b>int <a name="remove_from_one_image">remove_from_one_image</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi,int type, void *stuff);</b></div><br>
        general function used to detach data (labels, plots ...) from one image


<p><br>
<div class="al-api"><b>struct <a name="image_data">image_data</a></b></div><br>
<blockquote class="code"><pre>
{
        int data_type, mode;                    /* char, int or float */
        int nx, nxs, nxe;                       /* nb of x pixels */
        int ny ,nys, nye;                       /* nb of y pixels */
        union <a href="#pix" class="autotype" title="">pix</a> *pixel;                       /* the image data */
        union <a href="#pix" class="autotype" title="">pix</a> **pxl;                        /* the array for movie */
        void **mem;                             /* the array containing the starting point of memory of each image */
        int n_f, m_f, c_f;                      /* the number of images */
        unsigned char **over;                   /* overwrite plane 1 bit */
        unsigned long time;                     /* date of creation */
        char *source;
        char *history;
        char *treatement;
        char **special;                         /* strings for special infos*/
        int n_special, m_special;       
        struct hook use;                        /* usage of the image */
        unsigned char win_flag;                 /* boundary conditions */
        int movie_on_disk;                      /* specify if in memory or on disk */
        double record_duration;                 /* duration of data acquisition in micro seconds */
        long long record_start;                 /* start of duration of data */

};
</pre></blockquote>

<p>
The data type may be one of :

<blockquote class="text"><pre>

# define        IS_CHAR_IMAGE           // unsigned char 8 bits BW
# define        IS_RGB_PICTURE          // unsigned char 8 bits for each color coponents
# define        IS_RGBA_PICTURE         // unsigned char 8 bits for each color coponents + alpha channel
# define        IS_INT_IMAGE            // signed short int 16 bits BW
# define        IS_UINT_IMAGE           // unsigned short int 16 bits BW
# define        IS_LINT_IMAGE           // signed long int 32 bits BW
# define        IS_FLOAT_IMAGE          // float BW
# define        IS_COMPLEX_IMAGE        // complex image of float BW
# define        IS_DOUBLE_IMAGE         // double BW    
# define        IS_COMPLEX_DOUBLE_IMAGE // complex image of double BW
</pre></blockquote>




<p><br>
Accessing data is done via an union define here:

<p><br>
<div class="al-api"><b>union <a name="pix">pix</a>    </b></div><br>
<blockquote class="code"><pre>                             /* data pointer to pixel */
{
        unsigned char *ch;
        short int *in;
        unsigned short int *ui;
        int *li;
        float *fl;
        double *db;
        <a href="#mcomplex" class="autotype" title="">mcomplex</a> *cp;
        <a href="#mdcomplex" class="autotype" title="">mdcomplex</a> *dcp;
        <a href="#rgb" class="autotype" title="">rgb</a> *<a href="#rgb" class="autotype" title="">rgb</a>;
        <a href="#rgba" class="autotype" title="">rgba</a> *<a href="#rgba" class="autotype" title="">rgba</a>;
};
</pre></blockquote>

<p>
where elements are defined by the following structures :

<p><br>
<div class="al-api"><b>typedef struct typedef struct _mcomplex <a name="mcomplex">mcomplex</a>;</b></div><br>
<blockquote class="code"><pre>
{ 
        float re, im;
} 
</pre></blockquote>

<p><br>
<div class="al-api"><b>typedef struct _mdcomplex <a name="mdcomplex">mdcomplex</a>;</b></div><br>
<blockquote class="code"><pre>
{ 
        double dre, dim;
} 
</pre></blockquote>

<p><br>
<div class="al-api"><b>typedef struct _rgb <a name="rgb">rgb</a>;</b></div><br>
<blockquote class="code"><pre>
{ 
        unsigned char r, g, b;
} 
</pre></blockquote>

<p><br>
<div class="al-api"><b>typedef struct _rgba <a name="rgba">rgba</a>;</b></div><br>
<blockquote class="code"><pre>
{ 
        unsigned char r, g, b, a;
} 
</pre></blockquote>


<p><br>
Of couse, the right union member should be use according to image type : mdcomplex structure
will be valid only if the image is a COMPLEX_DOUBLE_IMAGE. Accesing data in an
image can be done in two ways depending on the fact that the data type is known or not:
If you are creating an image with an unsigned char type then to   
acces the pixel "j" of line "i" of an unsigned char image you should use :
<blockquote class="code"><pre>
        unsigned char u, *ul;
        <a href="#O_i" class="autotype" title="">O_i</a> *oi;  // a pointer to the image of interest
        // some code defining the image 
        u = oi->im.pixel[i].ch[j]; // this is the value of this pixel
        ul = oi->im.pixel[i].ch; // this is a pointer to the line i
        // or you can do the same thing by using macros 
        u = UCHAR_PIXEL(oi,i,j);
        ul = UCHAR_LINE_PTR(oi,i);
        // or you can do the same thing by using functions  
        u = <a href="#get_uchar_pixel" class="autotype" title="">get_uchar_pixel</a>(oi,i,j);
        ul = <a href="#uchar_line_ptr" class="autotype" title="">uchar_line_ptr</a>(oi,i);
</pre></blockquote>        

<p>
This macro method is the most efficient considering speed, the data are directly accessed however
no protection is provided in accessing out of bound data! the functions are slower but saffer.
Of course a set of macros and functions exist for all data type. 

<blockquote class="text"><pre>
# define        UCHAR_LINE_PTR(oi,line)     (oi)->im.pixel[(line)].ch
# define        SINT_LINE_PTR(oi,line)      (oi)->im.pixel[(line)].in
# define        UINT_LINE_PTR(oi,line)      (oi)->im.pixel[(line)].ui
# define        LINT_LINE_PTR(oi,line)      (oi)->im.pixel[(line)].li
# define        FLT_LINE_PTR(oi,line)       (oi)->im.pixel[(line)].fl
# define        DBL_LINE_PTR(oi,line)       (oi)->im.pixel[(line)].db
# define        RGB_LINE_PTR(oi,line)       (oi)->im.pixel[(line)].rgb
# define        RGBA_LINE_PTR(oi,line)      (oi)->im.pixel[(line)].rgba
# define        CFLT_LINE_PTR(oi,line)      (oi)->im.pixel[(line)].mcomplex
# define        CDBL_LINE_PTR(oi,line)      (oi)->im.pixel[(line)].mdcomplex

# define        UCHAR_PIXEL(oi,line,col)     (oi)->im.pixel[(line)].ch[(col)]
# define        SINT_PIXEL(oi,line,col)      (oi)->im.pixel[(line)].in[(col)]
# define        UINT_PIXEL(oi,line,col)      (oi)->im.pixel[(line)].ui[(col)]
# define        LINT_PIXEL(oi,line,col)      (oi)->im.pixel[(line)].li[(col)]
# define        FLT_PIXEL(oi,line,col)       (oi)->im.pixel[(line)].fl[(col)]
# define        DBL_PIXEL(oi,line,col)       (oi)->im.pixel[(line)].db[(col)]
# define        RGB_PIXEL(oi,line,col)       (oi)->im.pixel[(line)].rgb[(col)]
# define        RGBA_PIXEL(oi,line,col)      (oi)->im.pixel[(line)].rgba[(col)]
# define        CFLT_PIXEL(oi,line,col)      (oi)->im.pixel[(line)].mcomplex[(col)]
# define        CDBL_PIXEL(oi,line,col)      (oi)->im.pixel[(line)].mdcomplex[(col)]
</pre></blockquote>        

<p><br>
<div class="al-api"><b>unsigned char* <a name="uchar_line_ptr">uchar_line_ptr</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int line);</b></div><br>
<div class="al-api-cont"><b>short int* <a name="sint_line_ptr">sint_line_ptr</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int line);</b></div><br>
<div class="al-api-cont"><b>unsigned short int* <a name="uint_line_ptr">uint_line_ptr</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int line);</b></div><br>
<div class="al-api-cont"><b>int* <a name="lint_line_ptr">lint_line_ptr</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int line);</b></div><br>
<div class="al-api-cont"><b>float* <a name="flt_line_ptr">flt_line_ptr</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int line);</b></div><br>
<div class="al-api-cont"><b>double* <a name="dbl_line_ptr">dbl_line_ptr</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int line);</b></div><br>
<div class="al-api-cont"><b>rgb* <a name="rgb_line_ptr">rgb_line_ptr</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int line);</b></div><br>
<div class="al-api-cont"><b>rgba* <a name="rgba_line_ptr">rgba_line_ptr</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int line);</b></div><br>
<div class="al-api-cont"><b>mcomplex* <a name="cflt_line_ptr">cflt_line_ptr</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int line);</b></div><br>
<div class="al-api-cont"><b>mdcomplex* <a name="cdbl_line_ptr">cdbl_line_ptr</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int line);</b></div><br>


<p><br>
<div class="al-api"><b>unsigned char <a name="get_uchar_pixel">get_uchar_pixel</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int line, int col);</b></div><br>
<div class="al-api-cont"><b>short int <a name="get_sint_pixel">get_sint_pixel</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int line, int col);</b></div><br>
<div class="al-api-cont"><b>unsigned short int <a name="get_uint_pixel">get_uint_pixel</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int line, int col);</b></div><br>
<div class="al-api-cont"><b>int <a name="get_lint_pixel">get_lint_pixel</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int line, int col);</b></div><br>
<div class="al-api-cont"><b>float <a name="get_flt_pixel">get_flt_pixel</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int line, int col);</b></div><br>
<div class="al-api-cont"><b>double <a name="get_dbl_pixel">get_dbl_pixel</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int line, int col);</b></div><br>
<div class="al-api-cont"><b>rgb <a name="get_rgb_pixel">get_rgb_pixel</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int line, int col);</b></div><br>
<div class="al-api-cont"><b>rgba <a name="get_rgba_pixel">get_rgba_pixel</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int line, int col);</b></div><br>
<div class="al-api-cont"><b>mcomplex <a name="get_cflt_pixel">get_cflt_pixel</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int line, int col);</b></div><br>
<div class="al-api-cont"><b>mdcomplex get_cdbl_pixel(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int line, int col);</b></div><br>

<p><br>
<div class="al-api"><b>int <a name="get_raw_pixel_value">get_raw_pixel_value</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi,int ix, int iy, double *val)</b></div><br>
This function grabs the pixel at line iy and row ix and place the result
as a double in val whatever the image type is. ix and iy are tested to
be inside the defined image, whenever something is wrong, it shall return
an error code and 0 otherwise. This function handles all images type, this 
means that when the image is of complex type the returned value will be set
according to the visualization mode in use (real, imaginary amplitude ...).
In the same spirit, red, green, blue, alpha or grey level will be given
for rgb type pictures. The code of this function is given as an example. 
<blockquote class="code"><pre>
{
  double zr, zi;

        if (oi == NULL || ix < 0 || iy < 0 || ix >= oi->im.nx || iy >= oi->im.ny) 
          xvin_error(Wrong_Argument);
        switch (oi->im.data_type)
        {
                case  IS_CHAR_IMAGE:
                        *val = (double)oi->im.pixel[iy].ch[ix];
                break;
                case  IS_RGB_PICTURE:
                  if (oi->im.mode == GREY_LEVEL)
                        *val = ((double)(oi->im.pixel[iy].<a href="#rgb" class="autotype" title="">rgb</a>[ix].r + oi->im.pixel[iy].<a href="#rgb" class="autotype" title="">rgb</a>[ix].g 
                          + oi->im.pixel[iy].<a href="#rgb" class="autotype" title="">rgb</a>[ix].b))/3;
                  else if (oi->im.mode == R_LEVEL)
                        *val = (double)oi->im.pixel[iy].<a href="#rgb" class="autotype" title="">rgb</a>[ix].r;
                  else if (oi->im.mode == G_LEVEL)
                        *val = (double)oi->im.pixel[iy].<a href="#rgb" class="autotype" title="">rgb</a>[ix].g;
                  else if (oi->im.mode == B_LEVEL)
                        *val = (double)oi->im.pixel[iy].<a href="#rgb" class="autotype" title="">rgb</a>[ix].b;
                  else if (oi->im.mode == ALPHA_LEVEL)
                        *val = (double)255;
                  else return 1;
                break;                          
                case  IS_RGBA_PICTURE:
                  if (oi->im.mode == GREY_LEVEL)
                        *val = ((double)(oi->im.pixel[iy].<a href="#rgba" class="autotype" title="">rgba</a>[ix].r + oi->im.pixel[iy].<a href="#rgba" class="autotype" title="">rgba</a>[ix].g 
                          + oi->im.pixel[iy].<a href="#rgba" class="autotype" title="">rgba</a>[ix].b))/3;
                  else if (oi->im.mode == R_LEVEL)
                        *val = (double)oi->im.pixel[iy].<a href="#rgba" class="autotype" title="">rgba</a>[ix].r;
                  else if (oi->im.mode == G_LEVEL)
                        *val = (double)oi->im.pixel[iy].<a href="#rgba" class="autotype" title="">rgba</a>[ix].g;
                  else if (oi->im.mode == B_LEVEL)
                        *val = (double)oi->im.pixel[iy].<a href="#rgba" class="autotype" title="">rgba</a>[ix].b;
                  else if (oi->im.mode == ALPHA_LEVEL)
                        *val = (double)oi->im.pixel[iy].<a href="#rgba" class="autotype" title="">rgba</a>[ix].a;
                  else return 1;
                break;                          
                case  IS_INT_IMAGE:
                        *val = (double)oi->im.pixel[iy].in[ix];
                break;
                case  IS_UINT_IMAGE:
                        *val = (double)oi->im.pixel[iy].ui[ix];
                break;
                case  IS_LINT_IMAGE:
                        *val = (double)oi->im.pixel[iy].li[ix];
                break;                  
                case  IS_FLOAT_IMAGE:
                        *val = (double)oi->im.pixel[iy].fl[ix];
                break;                          
                case  IS_DOUBLE_IMAGE:
                        *val = oi->im.pixel[iy].db[ix];
                break;                          
                case  IS_COMPLEX_IMAGE:
                        zr = oi->im.pixel[iy].cp[ix].re;
                        zi = oi->im.pixel[iy].cp[ix].im;
                        switch (oi->im.mode)
                        {
                                case AMP:
                                *val = sqrt(zr*zr+zi*zi);
                                break;
                                case LOG_AMP:
                                *val = zr*zr+zi*zi;
                                *val = (*val > 0) ? log10(*val) : -40;
                                break;                          
                                case AMP_2:
                                *val = zr*zr+zi*zi;
                                break;
                                case RE:
                                *val = zr;
                                break;
                                case IM:
                                *val = zi;
                                break;
                        };
                break;                          
                case  IS_COMPLEX_DOUBLE_IMAGE:
                        zr = oi->im.pixel[iy].dcp[ix].dre;
                        zi = oi->im.pixel[iy].dcp[ix].dim;
                        switch (oi->im.mode)
                        {
                                case AMP:
                                *val = sqrt(zr*zr+zi*zi);
                                break;
                                case LOG_AMP:
                                *val = zr*zr+zi*zi;
                                *val = (*val > 0) ? log10(*val) : -80;
                                break;                          
                                case AMP_2:
                                *val = zr*zr+zi*zi;
                                break;
                                case RE:
                                *val = zr;
                                break;
                                case IM:
                                *val = zi;
                                break;
                        };
                break;                          
                default: return 1;
        }
        return 0;
}
</pre></blockquote>        

<p>
Possible mode values are :
<blockquote class="text"><pre>
# define        LOG_AMP         8
# define        AMP_2           16
# define        AMP             32
# define        RE              64
# define        IM              128
# define        KX              256
# define        KY              512
# define        PHI             1024
# define        GREY_LEVEL      0
# define        R_LEVEL         2048
# define        G_LEVEL         4096
# define        B_LEVEL         8192
# define        ALPHA_LEVEL     16384
</pre></blockquote>

<p><br>
<div class="al-api"><b>int <a name="set_oi_mode">set_oi_mode</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int mode);</b></div><br>
        allow to define the visualization mode of some image type. 

<p><br>
<div class="al-api"><b>int <a name="get_oi_mode">get_oi_mode</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        allow to grab the visualization mode of some image type. 


<p><br>
<div class="al-api"><b>int <a name="get_oi_type">get_oi_type</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        allows to grab the data type of an image, while the following macros
allow to test each case.

<blockquote class="text"><pre>
# define        OI_TYPE_IS_UNSIGNED_CHAR(oi)
# define        OI_TYPE_IS_RGB(oi)
# define        OI_TYPE_IS_RGBA(oi)
# define        OI_TYPE_IS_INT(oi)      
# define        OI_TYPE_IS_UNSIGNED_SHORT_INT(oi)
# define        OI_TYPE_IS_LONG_INT(oi) 
# define        OI_TYPE_IS_FLOAT(oi)    
# define        OI_TYPE_IS_DOUBLE(oi)   
# define        OI_TYPE_IS_COMPLEX(oi)  
# define        OI_TYPE_IS_COMPLEX_DOUBLE(oi)
</pre></blockquote>


<p><br>
/* data treatement */
<blockquote class="text"><pre>
# define        LOW_PASS        32
# define        BAND_PASS       64
# define        HIGH_PASS       128
# define        BRICK_WALL      8192
# define        REAL_MODE       512
# define        COMPLEX_MODE    1024
</pre></blockquote>

<p>
/* define boundary conditions */
<blockquote class="text"><pre>
# define        X_PER           1
# define        Y_PER           2
# define        X_NOT_PER       ~X_PER
# define        Y_NOT_PER       ~Y_PER
</pre></blockquote>



<p><br>
<div class="al-api"><b>int <a name="set_oi_region_of_interest_in_pixel">set_oi_region_of_interest_in_pixel</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int x0, int y0, int x1, int y1);</b></div><br>
        define the region of interest.

<p><br>
<div class="al-api"><b>int <a name="get_oi_region_of_interest_in_pixel">get_oi_region_of_interest_in_pixel</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int *x0, int *y0, int *x1, int *y1);</b></div><br>
        grab the region of interest.

<p><br>
<div class="al-api"><b>int <a name="set_oi_source">set_oi_source</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, char *format, ...);</b></div><br>
        define a string of variable size used to specify the image origin. The memory allocation
is done automatically. A sprintf syntax is supported.

<p><br>
<div class="al-api"><b>char* <a name="get_oi_source">get_oi_source</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        grab the string defining the image.

<p><br>
<div class="al-api"><b>int <a name="set_oi_treatement">set_oi_treatement</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, char *format, ...);</b></div><br>
        define a string of variable size used to specify the image last treatement. The memory allocation
is done automatically. A sprintf syntax is supported.

<p><br>
<div class="al-api"><b>char* <a name="get_oi_treatement">get_oi_treatement</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        grab the string defining the image treatement.

<p><br>
<div class="al-api"><b>int <a name="set_oi_history">set_oi_history</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, char *format, ...);</b></div><br>
        define a string of variable size used to specify the image succesive treatements. The memory allocation
is done automatically. A sprintf syntax is supported.

<p><br>
<div class="al-api"><b>char* <a name="get_oi_history">get_oi_history</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        grab the string defining the image history.


<p><br>
# define        set_oi_one_special(oi,text)     if ((oi) != NULL) \
                                                add_to_one_image ((oi), \
                                                IS_SPECIAL, (void *)(text))

                                                
<p><br>
<div class="al-api"><b>int <a name="set_oi_periodic_in_x">set_oi_periodic_in_x</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
<div class="al-api-cont"><b>int <a name="set_oi_periodic_in_y">set_oi_periodic_in_y</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
<div class="al-api-cont"><b>int <a name="set_oi_periodic_in_x_and_y">set_oi_periodic_in_x_and_y</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
<div class="al-api-cont"><b>int <a name="set_oi_not_periodic_in_x">set_oi_not_periodic_in_x</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
<div class="al-api-cont"><b>int <a name="set_oi_not_periodic_in_y">set_oi_not_periodic_in_y</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
<div class="al-api-cont"><b>int <a name="set_oi_not_periodic">set_oi_not_periodic</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        set image periodicity

<p><br>
<div class="al-api"><b>int <a name="get_oi_periodicity_in_x">get_oi_periodicity_in_x</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
<div class="al-api-cont"><b>int <a name="get_oi_periodicity_in_y">get_oi_periodicity_in_y</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        get image periodicity

<p><br>
<div class="al-api"><b>int <a name="set_oi_filename">set_oi_filename</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, char *file);</b></div><br>

<p><br>
<div class="al-api"><b>int <a name="set_oi_path">set_oi_path</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, char *dir);</b></div><br>

<p><br>
<div class="al-api"><b>char* <a name="get_oi_filename">get_oi_filename</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>

<p><br>
<div class="al-api"><b>char* <a name="get_oi_path">get_oi_path</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>

<blockquote class="text"><pre>
# define        set_oi_title                    set_im_title
# define        set_oi_x_title                  set_im_x_title
# define        set_oi_y_title                  set_im_y_title
# define        set_oi_x_top_title              set_im_x_top_title
# define        set_oi_y_right_title            set_im_y_right_title
</pre></blockquote>

<p><br>
<div class="al-api"><b>int <a name="set_im_title">set_im_title</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, char *format, ...);</b></div><br>
<div class="al-api-cont"><b>int <a name="set_im_x_title">set_im_x_title</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, char *format, ...);</b></div><br>
<div class="al-api-cont"><b>int <a name="set_im_y_title">set_im_y_title</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, char *format, ...);</b></div><br>
<div class="al-api-cont"><b>int <a name="set_im_x_top_title">set_im_x_top_title</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, char *format, ...);</b></div><br>
<div class="al-api-cont"><b>int <a name="set_im_y_right_title">set_im_y_right_title</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, char *format, ...);</b></div><br>
        define a string of variable size used to specify the image titles. The memory allocation
is done automatically. A sprintf syntax is supported

<p><br>
<div class="al-api"><b>char* <a name="get_oi_title">get_oi_title</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
<div class="al-api-cont"><b>char* <a name="get_oi_x_title">get_oi_x_title</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
<div class="al-api-cont"><b>char* <a name="get_oi_y_title">get_oi_y_title</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
<div class="al-api-cont"><b>char* <a name="get_oi_x_top_title">get_oi_x_top_title</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
<div class="al-api-cont"><b>char* <a name="get_oi_y_right_title">get_oi_y_right_title</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        Catches image titles.

<p><br>
<div class="al-api"><b>int <a name="alloc_over_plane">alloc_over_plane</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
<div class="al-api-cont"><b>int <a name="reset_full_over_plane">reset_full_over_plane</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, int val);</b></div><br>
<div class="al-api-cont"><b>int <a name="set_over">set_over</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, int x, int y);</b></div><br>


<p><br>
<div class="al-api"><b>int <a name="fast_interpolate_image_point">fast_interpolate_image_point</a> (<a class="autotype" href="#O_i" title="">O_i</a> *ois,float x,float y,int out_color);</b></div><br>
        This fuction interpolates images at fractional pixel position using
a linear interpolation scheme. Interpolate an unsigned char image value at position x and y
in pixel value in a fast manner, less accurate, if the point is outside of the image return 
out_color * 256 otherwise it output le value * 256. This routine only handle unsigned char 
image type.
 

<p><br>
<div class="al-api"><b>float <a name="interpolate_image_point">interpolate_image_point</a> (<a class="autotype" href="#O_i" title="">O_i</a> *ois, float x, float y, float *zr, float *zi);</b></div><br>
        This fuction interpolates images at fractional pixel position using
a linear interpolation scheme. The imaginay value will be filled if the image is of complex type
and if zi is not NULL;

<p><br>
<div class="al-api"><b>int <a name="interpolate_RGB_picture_point">interpolate_RGB_picture_point</a>(<a class="autotype" href="#O_i" title="">O_i</a> *ois, float x, float y, float *zr, float *zg, float *zb, float *za);</b></div><br>
        This fuction interpolates RGB and RGBA picture at fractional pixel position using
a linear interpolation scheme. 

<p><br>
<div class="al-api"><b>int <a name="extract_line">extract_line</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, int n_line, float *z);</b></div><br>
        Extract one line of an image and place it in the float array z which must have enough
space to accomodate the number of points in one line. The result is rescaled by the z unitset.

<p><br>
<div class="al-api"><b>int <a name="extract_row">extract_row</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, int n_row, float *z);</b></div><br>
        Extract one row of an image and place it in the float array z which must have enough
space to accomodate the number of points in one row. The result is rescaled by the z unitset.

<p><br>
<div class="al-api"><b>int <a name="extract_raw_line">extract_raw_line</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, int n_line, float *z);</b></div><br>
        Extract one line of an image and place it in the float array z which must have enough
space to accomodate the number of points in one line. The result is not rescaled by the z unitset.

<p><br>
<div class="al-api"><b>int <a name="extract_raw_row">extract_raw_row</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, int n_row, float *z);</b></div><br>
        Extract one row of an image and place it in the float array z which must have enough
space to accomodate the number of points in one row. The result is not rescaled by the z unitset.

<p><br>
<div class="al-api"><b>float* <a name="extract_tilted_profile">extract_tilted_profile</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, float *z, int nz, float x0, float y0, float x1, float y1, int *npts);</b></div><br>
<div class="al-api-cont"><b>float* <a name="extract_raw_tilted_profile">extract_raw_tilted_profile</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, float *z, int nz, float x0, float y0, float x1, float y1, int *npts);</b></div><br>
        Extract a profile of an image (oi) starting at point (x0, y0) 
ending at (x1, y1). Both points are included. The profile is
placed in a float array. If z is already allocated (!= NULL),
the routine use this array otherwise it allocate it (it is your
resposability fo free this array once used. The number of points
is calculated using the size of the segment in pixels. If x and y
scaling are different, the y scaling is the reference one. If the
number of points (nz) allocated for the array (z) is smaller than
the required size (*npts), this array is reallocated. The total 
number of points of the profile is returned in (npts).  
On error, npts is set to 0 and the functions return Null.
The raw type does not include the z uniset transformation


<p><br>
<div class="al-api"><b>int <a name="switch_frame">switch_frame</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi,int n);</b></div><br>
        For movies, this function allow to set the current image.

<p><br>
<div class="al-api"><b>int <a name="set_oi_horizontal_extend">set_oi_horizontal_extend</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, float width);</b></div><br>
<div class="al-api-cont"><b>int <a name="set_oi_vertical_extend">set_oi_vertical_extend</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, float height);</b></div><br>
        Define the width and height of the image a width and height = 1 means 512 
screen pixels (equivalent to screen_scale = PIXEL_0)    

<blockquote class="text"><pre>
# define        get_oi_horizontal_extend(oi) 
# define        get_oi_vertical_extend(oi) 
</pre></blockquote>
        These macros grab the extension of the image.

<p><br>
<div class="al-api"><b>int     <a name="map_pixel_ratio_of_image_and_screen">map_pixel_ratio_of_image_and_screen</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, float ratiox, float ratioy);</b></div><br>
<div class="al-api-cont"><b>int     <a name="what_is_pixel_ratio_of_image_and_screen">what_is_pixel_ratio_of_image_and_screen</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, float *ratiox, float *ratioy);</b></div><br>
        These functions allow to set or grab the image extension throught the ratio
between the size of the image pixel compared with that of the screen.


<blockquote class="text"><pre>
# define        set_oi_grid(oi,on_off)
# define        get_oi_grid(oi)                                                 

# define        USER            0
# define        PIXEL           1
# define        NO_NUMBER       2
</pre></blockquote>

<p>
On the screen, the image is surrouded by axis like a plot. The user may
erase these axis or choose what they represent. They may display the pixel
position or the user units. A mix representation may be done using the top
and bottom axis as well as the right and left axis.

<p><br>
<div class="al-api"><b>int <a name="set_oi_bottom_left_axes">set_oi_bottom_left_axes</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, int mode);</b></div><br>
        Choose the mode representation of the bottom and left axis, mode may be USER, PIXEL or
NO_NUMBER

<p><br>
<div class="al-api"><b>int <a name="is_oi_bottom_left_axes_in_pixel">is_oi_bottom_left_axes_in_pixel</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        Check for the bottom and left axis state.

<p><br>
<div class="al-api"><b>int <a name="is_oi_bottom_left_axes_numbered">is_oi_bottom_left_axes_numbered</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        Check for the bottom and left axis state.

<p><br>
<div class="al-api"><b>int <a name="set_oi_top_right_axes">set_oi_top_right_axes</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi,int pixel_user_nonumber_none);</b></div><br>
        Choose the mode representation of the top and right axis, mode may be USER, PIXEL or
NO_NUMBER

<p><br>
<div class="al-api"><b>int <a name="is_oi_top_right_axes_in_pixel">is_oi_top_right_axes_in_pixel</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        Check for the top and right axis state.

<p><br>
<div class="al-api"><b>int <a name="is_oi_top_right_axes_numbered">is_oi_top_right_axes_numbered</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        Check for the top and right axis state.

<p><br>
<div class="al-api"><b>int <a name="set_oi_plot_axes">set_oi_plot_axes</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi,int mode);</b></div><br>
        The plot that is diplayed on top of the image may have is X or Y axis varying in the
same manner or not. To link them, select mode to IM_SAME_X_AXIS or IM_SAME_Y_AXIS. To unlink
them select mode equal 0;

<p><br>
<div class="al-api"><b>int <a name="get_oi_plot_axes">get_oi_plot_axes</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        Determine how plot and image have their axis linked. Return IM_SAME_X_AXIS or IM_SAME_Y_AXIS or 0.

<p><br>
<div class="al-api"><b>int <a name="is_oi_x_axes_same_as_plot">is_oi_x_axes_same_as_plot</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        Simple test to check how plot and image have their X axis linked. Return 1 or 0.

<p><br>
<div class="al-api"><b>int <a name="is_oi_y_axes_same_as_plot">is_oi_y_axes_same_as_plot</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        Simple test to check how plot and image have their Y axis linked. Return 1 or 0.



<p><br>
All data may be converted to real physics values by the following macros
<blockquote class="text"><pre>     
# define        get_oi_x_user_coordinate(x)     (oi)->ax + (oi)->dx * (x)
# define        get_oi_y_user_coordinate(y)     (oi)->ay + (oi)->dy * (y)
# define        get_oi_z_user_coordinate(z)     (oi)->az + (oi)->dz * (z)
</pre></blockquote>

<p><br>
<div class="al-api"><b>char* <a name="get_oi_x_unit_name">get_oi_x_unit_name</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
<div class="al-api-cont"><b>char* <a name="get_oi_y_unit_name">get_oi_y_unit_name</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
<div class="al-api-cont"><b>char* <a name="get_oi_z_unit_name">get_oi_z_unit_name</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        grab the string defining the units in use for the specific axis.



<p><br>
/*
set_oi_region_of_interest(oi,pixel_user,x0,y0,x1,y1)
get_oi_region_of_interest(oi,pixel_user,*x0,*y0,*x1,*y1)


<p><br>
*/

<p><br>
<div class="al-api"><b>int <a name="set_zmin_zmax_values">set_zmin_zmax_values</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, float zmin, float zmax);</b></div><br>
        Define the maximum and the minimum of the z scale.

<p><br>
<div class="al-api"><b>int <a name="set_z_black_z_white_values">set_z_black_z_white_values</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, float zb, float zw);</b></div><br>
        Define the z level associated with back and white.

<p><br>
<div class="al-api"><b>int <a name="get_zmin_zmax_values">get_zmin_zmax_values</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, float *zmin, float *zmax);</b></div><br>
        Get the maximum and the minimum of the z scale.

<p><br>
<div class="al-api"><b>int <a name="get_z_black_z_white_values">get_z_black_z_white_values</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, float *zb, float *zw);</b></div><br>
        Ge t the z level associated with back and white.

<p><br>
<div class="al-api"><b>int <a name="find_zmin_zmax">find_zmin_zmax</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        Find automatically the values of zmin and zmax.

<p><br>
<div class="al-api"><b>O_p* <a name="create_and_attach_op_to_oi">create_and_attach_op_to_oi</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi,int nx,int ny,int type, int axis_type);</b></div><br>
        This functionn create a plot having one data set with nx and ny points, and attach it to an image. 
So far the type is not used, the axis_type allow to link the plot axis to that of the image it may 
be set to IM_SAME_X_AXIS or IM_SAME_Y_AXIS or 0. Returns the pointer to the plot structure on sucess or
Null on error.

<p><br>
<div class="al-api"><b>d_s* <a name="create_and_attach_ds_to_oi">create_and_attach_ds_to_oi</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi,int nx,int ny,int type);</b></div><br>
        This functionn create a data set having nx and ny points, and attach it to the current 
plot attached to the image oi. So far the type is not used, the axis_type allow to link the 
plot axis to that of the image it may be set to IM_SAME_X_AXIS 
or IM_SAME_Y_AXIS or 0. Returns the pointer to the data set structure on sucess or
Null on error or if not plot is associated to the image oi.

<p><br>
<div class="al-api"><b>O_p* <a name="find_oi_cur_op">find_oi_cur_op</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        Return the pointer to the current plot structure associated with oi on sucess or Null otherwise.

        
<p><br>
<div class="al-api"><b>p_l* <a name="create_and_attach_label_to_oi">create_and_attach_label_to_oi</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, float x, float y, int type, const char *format, ...);</b></div><br>
        This function creates a label and attaches it to the image oi at a position defined by x, y 
in pixel unit. The label is define using the printf format, the label structure and text string are
allocated automatically. Type may be one of these ABS_COORD, USR_COORD, VERT_LABEL_USR, VERT_LABEL_ABS,
, WHITE_LABEL, OVER_WHITE;


<blockquote class="code"><pre>     
        <a href="xvin000.html#p_l" class="autotype" title="">p_l</a> *pl;
        pl = <a href="#create_and_attach_label_to_oi" class="autotype" title="">create_and_attach_label_to_oi</a> (oi, 100, 200, USR_COORD, "Image %d",i);
</pre></blockquote>      


<p><br>
<div class="al-api"><b>un_s* <a name="create_and_attach_unit_set_to_oi">create_and_attach_unit_set_to_oi</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, int type, float ax, float dx, char decade, char mode, char *name, int axis);</b></div><br>
        Each axis, X, Y, Z, and T may be assigned a unit set which modify the raw unit (pixels, z level
or frame number) by an affine transformation and give it a physical unit (microns, seconds ...). Multiple
unit set be attached at each axis. This function allow to create and attach a new unit set to an axis
of an image oi. axis may be IS_X_UNIT_SET, IS_Y_UNIT_SET, IS_Z_UNIT_SET or IS_T_UNIT_SET;


<blockquote class="text"><pre>     
#define create_attach_select_x_un_to_oi(oi, type, ax, dx, decade, mode, name)\
#define create_attach_select_y_un_to_oi(oi, type, ax, dx, decade, mode, name)\
</pre></blockquote>      
        These macros are define as sortcuts.

<p><br>
<div class="al-api"><b>int <a name="push_image_label">push_image_label</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, float tx, float ty, char *label, int type);</b></div><br>
        This function is deprecate, it attaches a label to an image, better use create_and_attach_label_to_oi

<blockquote class="text"><pre>     
# define        remove_cur_op_from_oi(oi)
# define        remove_op_from_oi(oi,op)        
# define        remove_label_from_oi(oi,pl)     
# define        remove_x_unit_set_from_oi(oi,un)
# define        remove_y_unit_set_from_oi(oi,un)
# define        remove_z_unit_set_from_oi(oi,un)
</pre></blockquote>      
        Macros used to remove stuff from the image oi. The data structure are also freed.



<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#create_and_attach_label_to_oi" title="">create_and_attach_label_to_oi</a>.</blockquote>
<div class="al-api"><b>int   <a name=""></a>(image_special_2_use) (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        This is a pointer to a function that the user may define to perfom customized change of an image.
The "use" is a hook that the user may use to attach its own data structure. The special strings that can
be read from the image file can be use to set the value to the user define structure. If this function
is defined, it will be executed after the image file is read. This function will typically allocate the
user structure and parse the special string to set the structure member to their appropriate value.
 
<p><br>
<div class="al-api"><b>int   <a name=""></a>(image_use_2_special) (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        This is a pointer to a function that the user may define to perfom customized change of an image.
This function if defined will be executed before saving an image to a file. The idea is that this function
will define a series of specials containing the values of the structure.

<p><br>
<div class="al-api"><b>int <a name=""></a>(image_free_use) (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        This is a pointer to a function that the user may define to perfom customized change of an image.
This function will be executed when an image is destroy. If defined, this function is used by the user
to free the data structure attached to the use hook.

<p><br>
<div class="al-api"><b>int   <a name=""></a>(image_duplicate_use) (<a class="autotype" href="#O_i" title="">O_i</a> *oid, <a class="autotype" href="#O_i" title="">O_i</a> *ois);</b></div><br>
        This is a pointer to a function that the user may define to perfom customized change of an image.
This function will be executed when an image is copied. If defined, this function is used by the user
to duplicate the data structure attached to the use hook.


<p><br>
<div class="al-api"><b>int <a name="save_one_image">save_one_image</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, char *file);</b></div><br>
        This function save the image to disk using the full filename defined by file.


<p><br>
<div class="al-api"><b>#define       <a name="inherit_from_oi_to_oi">inherit_from_oi_to_oi</a>          inherit_from_im_to_im</b></div><br>
<div class="al-api-cont"><b>int <a name="inherit_from_im_to_im">inherit_from_im_to_im</a> (<a class="autotype" href="#O_i" title="">O_i</a> *dest, <a class="autotype" href="#O_i" title="">O_i</a> *src);</b></div><br>
        This function is a housekkeeping one, it is made to be used when you build a new image from
an already existing one, it will transfer the properties of the original to the copied one. 
Thus it will copied the source, the path, the options, the width, the height. It will transfer
the filename and add the treatement of the source image to the history of the destination one. 

<p><br>
<div class="al-api"><b>#define       <a name="inherit_from_oi_to_ds">inherit_from_oi_to_ds</a>          inherit_from_im_to_ds</b></div><br>
<div class="al-api-cont"><b>int <a name="inherit_from_im_to_ds">inherit_from_im_to_ds</a> (d_s *dest, <a class="autotype" href="#O_i" title="">O_i</a> *src);</b></div><br>
        This function is a housekkeeping one, it is made to be used when you build a plot from
an already existing image, it will transfer the properties of the original image to the dataset. 

<p><br>
<div class="al-api"><b>int <a name="inherit_from_ds_to_ds">inherit_from_ds_to_ds</a> (d_s *dest, d_s *src);</b></div><br>
        This function is a housekkeeping one, it is made to be used when you build a dataset from
an already existing one, it will transfer the properties of the original dataset to the copied one. 




<p><br>
<div class="al-api"><b>int <a name="set_oi_x_unit_set">set_oi_x_unit_set</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, int n);</b></div><br>
        Select the active unitset to be used for the X axis.

<p><br>
<div class="al-api"><b>int <a name="set_oi_y_unit_set">set_oi_y_unit_set</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, int n);</b></div><br>
        Select the active unitset to be used for the Y axis.

<p><br>
<div class="al-api"><b>int <a name="set_oi_z_unit_set">set_oi_z_unit_set</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, int n);</b></div><br>
        Select the active unitset to be used for the Z axis.


<p><br>
<div class="al-api"><b>int <a name="uns_oi_2_op">uns_oi_2_op</a> (<a class="autotype" href="#O_i" title="">O_i</a> *ois, int oi_type, O_p *op, int op_type);</b></div><br>
        Whenever you construct a plot from an image, you will have transfer the unitset of the
image ois to the plot op. oi_type may be one of IS_X_UNIT_SET, IS_Y_UNIT_SET, IS_Z_UNIT_SET, 
IS_T_UNIT_SET. While op_type may be one of IS_X_UNIT_SET, IS_Y_UNIT_SET.
 
<p><br>
<div class="al-api"><b>int <a name="uns_oi_2_oi">uns_oi_2_oi</a> (<a class="autotype" href="#O_i" title="">O_i</a> *dest, <a class="autotype" href="#O_i" title="">O_i</a> *src);</b></div><br>
        Transfer all unitset from drc image to dest.

<p><br>
<div class="al-api"><b>int <a name="uns_op_2_oi">uns_op_2_oi</a> (O_p *op, int op_type, <a class="autotype" href="#O_i" title="">O_i</a> *oid, int oi_type);</b></div><br>
        Whenever you construct an image from a plot, you will have transfer the unitset of the
plot op to the image oid. oi_type may be one of IS_X_UNIT_SET, IS_Y_UNIT_SET, IS_Z_UNIT_SET, 
IS_T_UNIT_SET. While op_type may be one of IS_X_UNIT_SET, IS_Y_UNIT_SET.

<p><br>
<div class="al-api"><b>int <a name="uns_oi_2_oi_by_type">uns_oi_2_oi_by_type</a> (<a class="autotype" href="#O_i" title="">O_i</a> *ois, int ois_type, <a class="autotype" href="#O_i" title="">O_i</a> *oid, int oid_type);</b></div><br>
        Whenever you construct an image from another image, you will have transfer the unitset of the
fist image ois to the second oid. However your second image may have only one axis in common with the
first one, this function allow just to do that. ois_type and oid_type may be one of IS_X_UNIT_SET, 
IS_Y_UNIT_SET, IS_Z_UNIT_SET, IS_T_UNIT_SET. 

<p><br>
<div class="al-api"><b>int <a name="affine_transform_all_image_unitset">affine_transform_all_image_unitset</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, int type, float offset, float multiplier);</b></div><br>
        This function allows to modify all the unitset of one axis at a time.


<p><br>
<div class="al-api"><b>int <a name="swap_image">swap_image</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>


<p><br>
<div class="al-api"><b>int <a name="find_op_nb_of_source_specific_ds_in_oi">find_op_nb_of_source_specific_ds_in_oi</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, char *source);</b></div><br>
        This function is used to retrieve a plot having a specific source in an image. The return
value is the plot number on sucess or -1 otherwise. 

<p><br>
<div class="al-api"><b>int <a name="find_op_nb_of_treatement_specific_ds_in_oi">find_op_nb_of_treatement_specific_ds_in_oi</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, char *treatement);</b></div><br>
        This function is used to retrieve a plot having a specific treatement in an image. The return
value is the plot number on sucess or -1 otherwise. 



<p><br>
<div class="al-api"><b>imreg* <a name="build_image_region">build_image_region</a>(int x0, int y0, int width, int height, int type);</b></div><br>
        This function creates an image region that will be used to display image data. It creates
this structure with one image which memory space for real data has not yet been allocated.

<p><br>
<div class="al-api"><b>imreg* <a name="build_an_empty_image_region">build_an_empty_image_region</a>(int x0, int y0, int width, int height);</b></div><br>
        This function creates an image region that will be used to display image data. It creates
this structure without any image.

<p><br>
<div class="al-api"><b>int <a name="free_image_region">free_image_region</a> (imreg* imr);</b></div><br>
        Destroy and free the image region as well as all its elemnents in particular all the
images attached to it.

<p><br>
<div class="al-api"><b>O_i* <a name="create_and_attach_oi_to_imr">create_and_attach_oi_to_imr</a>(imreg *imr, int nx, int ny, int type);</b></div><br>
        Create and attach a new image data structure to an existing image region. It returns
the pointer to the O_i on success otherwise NULL.

<p><br>
<div class="al-api"><b>int <a name="alloc_image">alloc_image</a>(imreg *imr, int nx, int ny, int type));</b></div><br>
        This functions allocate or reallocate the image data memory necessary to hold an image.

<p><br>
<div class="al-api"><b>imreg* <a name="create_imreg_with_movie">create_imreg_with_movie</a>(int nx, int ny, int data_type, int n_frames);</b></div><br>
        This function creates an image region that will be used to display image data. It creates
this structure with one move which memory space has been allocated.
        
<p><br>
<div class="al-api"><b>O_i*  <a name="create_and_attach_movie_to_imr">create_and_attach_movie_to_imr</a>(imreg *imr, int nx, int ny, int type, int nf);</b></div><br>
        Create and attach a new movie data structure to an existing image region. It returns
the pointer to the O_i on success otherwise NULL.

<p><br>
<div class="al-api"><b>int <a name="select_image_of_imreg">select_image_of_imreg</a>(imreg *imr, int n);</b></div><br>
        Switch the current image of an image region to that having number n;

<p><br>
<div class="al-api"><b>int <a name="select_image_of_imreg_and_display">select_image_of_imreg_and_display</a>(imreg *imr, int n);</b></div><br>
        Switch the current image of an image region to that having number n and display that image
on screen.

<p><br>
<div class="al-api"><b>int <a name="add_image">add_image</a>(imreg *imr, int type, void *stuff);</b></div><br>
<div class="al-api-cont"><b>int <a name="add_to_image">add_to_image</a>(imreg *imr, int type, void *stuff);</b></div><br>
<div class="al-api-cont"><b>int <a name="remove_image">remove_image</a>(imreg *imr, int type, void *stuff);</b></div><br>
<div class="al-api-cont"><b>int <a name="remove_from_image">remove_from_image</a>(imreg *imr, int type, void *stuff);</b></div><br>

<p><br>
<div class="al-api"><b>#define <a name="find_im_cur_oi">find_im_cur_oi</a>(imr)  (imr)->one_i </b></div><br>
        Grab the current image pointer.

<p><br>
<div class="al-api"><b>O_p* <a name="find_im_cur_op">find_im_cur_op</a>(imreg *imr);</b></div><br>
        Grab the plot associated to the current image. Returns the pointer to O_P on sucess or
Null otherwise

<p><br>
<div class="al-api"><b>int <a name="x_imdata_2_imr">x_imdata_2_imr</a>(imreg *imr, int x);</b></div><br>
<div class="al-api-cont"><b>int <a name="y_imdata_2_imr">y_imdata_2_imr</a>(imreg *imr, int y);</b></div><br>
<div class="al-api-cont"><b>float <a name="x_imr_2_imdata">x_imr_2_imdata</a>(imreg *imr, int x);</b></div><br>
<div class="al-api-cont"><b>float <a name="y_imr_2_imdata">y_imr_2_imdata</a>(imreg *imr, int y);</b></div><br>

<p><br>
<div class="al-api"><b>float <a name="x_imr_2_im_user_data">x_imr_2_im_user_data</a>(imreg *imr, int x);</b></div><br>
<div class="al-api-cont"><b>float <a name="y_imr_2_im_user_data">y_imr_2_im_user_data</a>(imreg *imr, int y);</b></div><br>

<p><br>
<div class="al-api"><b>int <a name="x_pltdata_2_imr">x_pltdata_2_imr</a>(imreg *imr, float x);</b></div><br>
<div class="al-api-cont"><b>int <a name="y_pltdata_2_imr">y_pltdata_2_imr</a>(imreg *imr, float y);</b></div><br>
<div class="al-api-cont"><b>float <a name="x_imr_2_pltdata">x_imr_2_pltdata</a>(imreg *imr, int yvp);</b></div><br>
<div class="al-api-cont"><b>float <a name="y_imr_2_pltdata">y_imr_2_pltdata</a>(imreg *imr, int xvp);</b></div><br>

<p><br>
<div class="al-api"><b>int <a name="set_im_x_unit_set">set_im_x_unit_set</a>(imreg *imr, int n);</b></div><br>
<div class="al-api-cont"><b>int <a name="set_im_y_unit_set">set_im_y_unit_set</a>(imreg *imr, int n);</b></div><br>
<div class="al-api-cont"><b>int <a name="set_im_z_unit_set">set_im_z_unit_set</a>(imreg *imr, int n);</b></div><br>

<p><br>
<div class="al-api"><b>int <a name="do_one_image">do_one_image</a>(imreg *imr);</b></div><br>

<p><br>
<div class="al-api"><b>int <a name="draw_box_im">draw_box_im</a>(int dx, int dy, int scale, int color);</b></div><br>
<div class="al-api-cont"><b>int <a name="erase_imr_box">erase_imr_box</a>(imreg *imr);</b></div><br>
<div class="al-api-cont"><b>int <a name="draw_box_imr_plot">draw_box_imr_plot</a>(imreg *imr, int color);</b></div><br>

<p><br>
<div class="al-api"><b>int <a name="refresh_im_plot">refresh_im_plot</a>(imreg *imr, int n_plot);</b></div><br>
<div class="al-api-cont"><b>int <a name="refresh_image">refresh_image</a>(imreg *imr, int n_im);</b></div><br>

<p><br>
<div class="al-api"><b>imreg* <a name="find_imr_in_current_dialog">find_imr_in_current_dialog</a>(DIALOG *di);</b></div><br>


<p><br>
<div class="al-api"><b>int <a name="load_im_file_in_imreg">load_im_file_in_imreg</a> (imreg *imr, char *file, char *path);</b></div><br>
<div class="al-api-cont"><b>int <a name="imreadfile">imreadfile</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, char *file_name);</b></div><br>


<p><br>
<div class="al-api"><b>int <a name="set_image_starting_time">set_image_starting_time</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        synchronize the time field of the image structure with the actual time and initiate
the micro-second counter to measure the duration of a data acquisition.


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#set_image_ending_time" title="">set_image_ending_time</a>.</blockquote>
<div class="al-api"><b>int <a name="set_image_ending_time">set_image_ending_time</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi);</b></div><br>
        ends the micro-second counter to measure the duration of a data acquisition.


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#set_image_starting_time" title="">set_image_starting_time</a>.</blockquote>
<div class="al-api"><b>int <a name="switch_frame_of_disk_movie">switch_frame_of_disk_movie</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, int f);</b></div><br>
        loads from disk the specified image as the current frame in a movie (filename and path
must be defined to a valid file!)

<p><br>
<div class="al-api"><b>int <a name="find_CTRL_Z_offset">find_CTRL_Z_offset</a> (<a class="autotype" href="#O_i" title="">O_i</a> *oi, FILE *fp);</b></div><br>
        internal function needed to grab the file header size which corresponds to the
offset to the first frame of the movie on disk.
 
<p><br>
<div class="al-api"><b>int <a name="save_image_header">save_image_header</a> (O_i* oi, char *head, int size);</b></div><br>
        This function is used to save the header part of the file associated to a movie. You do
not need to know the exact number of frames going to be recorded, this parameter may be 
overwritten at the end of acquisition by using close_movie_on_disk.
 

<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#close_movie_on_disk" title="">close_movie_on_disk</a>.</blockquote>
<div class="al-api"><b>int <a name="close_movie_on_disk">close_movie_on_disk</a>(<a class="autotype" href="#O_i" title="">O_i</a> *oi, int nf);</b></div><br>
        This function is used to overwritte the file header at the end of acquisition 
it allows to specify the actual number of frames recorded and to record the acquisition
duration.


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#save_image_header" title="">save_image_header</a>.</blockquote>
<hr><div class="al-back-to-contents"><a href="xvin.html">Back to contents</a></div>

</body>
</html>
